#include <bits/stdc++.h>
using namespace std;
using uint = unsigned int;
using ll = long long;
using pii = pair<int, int>;
#define dbg(x) cerr<<#x": "<<(x)<<'\n'
#define dbg_v(x, n) cerr<<#x"[]: ";for(long long _=0;_<n;++_)cerr<<(x)[_]<<' ';cerr<<'\n'
#define all(v) v.begin(), v.end()
#define NMAX 100010
#define VMAX 1000010
#define QMAX 200010
#define BSIZE 330

struct query
{
	int l, r, id;

	query(int _l, int _r, int _id) : 
		l(_l), r(_r), id(_id) {}

	bool operator <(const query &q) const
	{
		return r < q.r;
	}
};

int n, s;
int v[NMAX], freq[VMAX];
ll cnt;

void inc(int p)
{
	if(s >= v[p]) cnt += freq[s - v[p]];
	++freq[v[p]];
}

void dec(int p)
{
	--freq[v[p]];
	if(s >= v[p]) cnt -= freq[s - v[p]];
}

int main()
{
#ifndef ONLINE_JUDGE
	ifstream cin("suma.in");
	ofstream cout("suma.out");
#endif
	ios_base::sync_with_stdio(false);

	int i, q, l, r, a, b;

	cin >> n >> s;
	for(i = 1; i <= n; ++i) cin >> v[i];

	cin >> q;
	r = 0; l = 1;
	for(i = 0; i < q; ++i)
	{
		cin >> a >> b;
		while(l < a) dec(l), ++l;
		while(l > a) --l, inc(l);
		while(r < b) ++r, inc(r);
		while(r > b) dec(r), --r;

		cout << cnt << '\n';
	}

	return 0;
}
