#include <iostream>
#include <fstream>
#include <vector>

#define VALMAX 1000010
#define NMAX 100010

using namespace std;

ifstream f("suma.in");
ofstream g("suma.out");

int fr[VALMAX];
int n, s;
int a[NMAX];

void citeste() {
	f >> n >> s;
	for (int i = 1; i <= n; ++i) {
		f >> a[i];
	}
}


long long solve_query(const int st, const int dr) {
	long long rez = 0;
	for (int i = st; i <= dr; ++i) {
		++fr[a[i]];
	}
	for (int i = st; i <= dr; ++i) {
		if (s - a[i] >= 0) {
			rez += fr[s-a[i]];
		}
	}
	for (int i = st; i <= dr; ++i) {
		--fr[a[i]];
	}
	return rez / 2;
}

void rezolva() {
	int m, st, dr;
	f >> m;
	while (m--) {
		f >> st >> dr;
		g << solve_query(st, dr) << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	citeste();

	rezolva();

	f.close();
	g.close();
	return 0;
}
